

self.port.on("showCurrentDeviceName", function handleShowCurrentDeviceName(storage) {
	setStorage(storage);
	showCurrentDeviceName();
});

self.port.on("showError", function handleShowError(msg) {
	showError(msg);
});


function setStorage(storage) {
	try {
		localStorage["device_name"] = storage.device_name;
		localStorage["pair_key"] = storage.pair_key;
	}
	catch(e) {
		// do nothing
	}
}


// Tries to pair device using pairing code and stores information in localStorage
function pairDevice() {
  var pair_code = document.getElementById("pair_code").value;
  
  if (pair_code.length == 0) {
	  showError("Please provide pairing code!");
	  return;
  }

  self.port.emit("pairDevice", pair_code);  
}


//prevent form submit on enter
function checkEnter(e) {
	if (e.which == 13) {
		e.preventDefault();
		pairDevice();
	}
	
	return false;
}


// Shows currently paired device name or info to pair one
function showCurrentDeviceName() {
  var status = document.getElementById("status");
  if (status == undefined) {
	  return;
  }
  
  status.style.color = "black";
  
  var device_name = localStorage["device_name"];
  var pair_key = localStorage["pair_key"];
  
  if (!device_name || !pair_key) {
	  status.innerHTML = "You don't have paired device!";
  } else {
	  status.innerHTML = "Currently paired device is " + device_name;
  }
}

// Shows error for 5 seconds
function showError(msg) {
	var status = document.getElementById("status");
	status.innerHTML = msg;
	status.style.color = "red";

	setTimeout(function() {showCurrentDeviceName()}, 2500);
}


//initialization
document.addEventListener('DOMContentLoaded', function() {
	document.getElementById('pair_device').addEventListener('click', pairDevice);
	document.getElementById('pair_device').addEventListener('keypress', pairDevice);
	document.getElementById('pairing-form').addEventListener('keypress', checkEnter);
});
